/*
     http://code.google.com/p/simple-opencl/
*/

/* #######################################################################
    Copyright 2011 Oscar Amoros Huguet, Cristian Garcia Marin

    This file is part of SimpleOpenCL.

    SimpleOpenCL is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3.

    SimpleOpenCL is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SimpleOpenCL. If not, see <http://www.gnu.org/licenses/>.

   #######################################################################

   SimpleOpenCL Version 0.09_01_10_2011
*/


/* ####### Debug functions ################################ */

void sclPrintErrorFlag( cl_int flag );
//void sclPrintDeviceNamePlatforms( sclHard* hardList, int found );

/* ######################################################## */



void sclPrintErrorFlag(cl_int flag)
{
   switch (flag)
   {
      case CL_DEVICE_NOT_FOUND:
         printf("CL_DEVICE_NOT_FOUND\n");
         break;
      case CL_DEVICE_NOT_AVAILABLE:
         printf("CL_DEVICE_NOT_AVAILABLE\n");
         break;
      case CL_COMPILER_NOT_AVAILABLE:
         printf("CL_COMPILER_NOT_AVAILABLE\n");
         break;
      case CL_PROFILING_INFO_NOT_AVAILABLE:
         printf("CL_PROFILING_INFO_NOT_AVAILABLE\n");
         break;
      case CL_MEM_COPY_OVERLAP:
         printf("CL_MEM_COPY_OVERLAP\n");
         break;
      case CL_IMAGE_FORMAT_MISMATCH:
         printf("CL_IMAGE_FORMAT_MISMATCH\n");
         break;
      case CL_IMAGE_FORMAT_NOT_SUPPORTED:
         printf("CL_IMAGE_FORMAT_NOT_SUPPORTED\n");
         break;
      case CL_INVALID_COMMAND_QUEUE:
         printf("CL_INVALID_COMMAND_QUEUE\n");
         break;
      case CL_INVALID_CONTEXT:
         printf("CL_INVALID_CONTEXT\n");
         break;
      case CL_INVALID_MEM_OBJECT:
         printf("CL_INVALID_MEM_OBJECT\n");
         break;
      case CL_INVALID_VALUE:
         printf("CL_INVALID_VALUE\n");
         break;
      case CL_INVALID_EVENT_WAIT_LIST:
         printf("CL_INVALID_EVENT_WAIT_LIST\n");
         break;
      case CL_MEM_OBJECT_ALLOCATION_FAILURE:
         printf("CL_MEM_OBJECT_ALLOCATION_FAILURE\n");
         break;
      case CL_OUT_OF_HOST_MEMORY:
         printf("CL_OUT_OF_HOST_MEMORY\n");
         break;

      case CL_INVALID_PROGRAM_EXECUTABLE:
         printf("CL_INVALID_PROGRAM_EXECUTABLE\n");
         break;
      case CL_INVALID_KERNEL:
         printf("CL_INVALID_KERNEL\n");
         break;
      case CL_INVALID_KERNEL_ARGS:
         printf("CL_INVALID_KERNEL_ARGS\n");
         break;
      case CL_INVALID_WORK_DIMENSION:
         printf("CL_INVALID_WORK_DIMENSION\n");
         break;
      #ifndef __APPLE__
      case CL_INVALID_GLOBAL_WORK_SIZE:
         printf("CL_INVALID_GLOBAL_WORK_SIZE\n");
         break;
      #endif
      case CL_INVALID_WORK_GROUP_SIZE:
         printf("CL_INVALID_WORK_GROUP_SIZE\n");
         break;
      case CL_INVALID_WORK_ITEM_SIZE:
         printf("CL_INVALID_WORK_ITEM_SIZE\n");
         break;
      case CL_INVALID_GLOBAL_OFFSET:
         printf("CL_INVALID_GLOBAL_OFFSET\n");
         break;
      case CL_OUT_OF_RESOURCES:
         printf("CL_OUT_OF_RESOURCES\n");
         break;

      case CL_INVALID_PROGRAM:
         printf("CL_INVALID_PROGRAM\n");
         break;
      case CL_INVALID_KERNEL_NAME:
         printf("CL_INVALID_KERNEL_NAME\n");
         break;
      case CL_INVALID_KERNEL_DEFINITION:
         printf("CL_INVALID_KERNEL_DEFINITION\n");
         break;
      case CL_INVALID_BUFFER_SIZE:
         printf("CL_INVALID_BUFFER_SIZE\n");
         break;
      case CL_BUILD_PROGRAM_FAILURE:
         printf("CL_BUILD_PROGRAM_FAILURE\n");
         break;
      case CL_INVALID_ARG_INDEX:
         printf("CL_INVALID_ARG_INDEX\n");
         break;
      case CL_INVALID_ARG_VALUE:
         printf("CL_INVALID_ARG_VALUE\n");
         break;
      case CL_MAP_FAILURE:
         printf("CL_MAP_FAILURE\n");
         break;
      case CL_MISALIGNED_SUB_BUFFER_OFFSET:
         printf("CL_MISALIGNED_SUB_BUFFER_OFFSET\n");
         break;
      case CL_EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST:
         printf("CL_EXEC_STATUS_ERROR_FOR_EVENTS_IN_WAIT_LIST\n");
         break;
      case CL_INVALID_DEVICE_TYPE:
         printf("CL_INVALID_DEVICE_TYPE\n");
         break;
      case CL_INVALID_PLATFORM:
         printf("CL_INVALID_PLATFORM\n");
         break;
      case CL_INVALID_DEVICE:
         printf("CL_INVALID_DEVICE\n");
         break;
      case CL_INVALID_QUEUE_PROPERTIES:
         printf("CL_INVALID_QUEUE_PROPERTIES\n");
         break;
      case CL_INVALID_HOST_PTR:
         printf("CL_INVALID_HOST_PTR\n");
         break;
      case CL_INVALID_IMAGE_FORMAT_DESCRIPTOR:
         printf("CL_INVALID_IMAGE_FORMAT_DESCRIPTOR\n");
         break;
      case CL_INVALID_IMAGE_SIZE:
         printf("CL_INVALID_IMAGE_SIZE\n");
         break;
      case CL_INVALID_SAMPLER:
         printf("CL_INVALID_SAMPLER\n");
         break;
      case CL_INVALID_BINARY:
         printf("CL_INVALID_BINARY\n");
         break;
      case CL_INVALID_BUILD_OPTIONS:
         printf("CL_INVALID_BUILD_OPTIONS\n");
         break;
      case CL_INVALID_ARG_SIZE:
         printf("CL_INVALID_ARG_SIZE\n");
         break;
      case CL_INVALID_EVENT:
         printf("CL_INVALID_EVENT\n");
         break;
      case CL_INVALID_OPERATION:
         printf("CL_INVALID_OPERATION\n");
         break;
      case CL_INVALID_GL_OBJECT:
         printf("CL_INVALID_GL_OBJECT\n");
         break;
      case CL_INVALID_MIP_LEVEL:
         printf("CL_INVALID_MIP_LEVEL\n");
         break;
      case CL_INVALID_PROPERTY:
         printf("CL_INVALID_PROPERTY\n");
         break;
      default:
         printf("Unknown error code: %d\n",flag);
   }
}


/*
void sclPrintDeviceNamePlatforms( sclHard* hardList, int found )
{
   int i;
   cl_char deviceName[1024];
   cl_char platformVendor[1024];
   cl_char platformName[1024];

   for ( i = 0; i < found; ++i )
   {
      clGetPlatformInfo( hardList[i].platform,
                         CL_PLATFORM_NAME,
                         sizeof(cl_char)*1024,
                         platformName,
                         NULL );
      clGetPlatformInfo( hardList[i].platform,
                         CL_PLATFORM_VENDOR,
                         sizeof(cl_char)*1024,
                         platformVendor,
                         NULL );
      clGetDeviceInfo( hardList[i].device,
                       CL_DEVICE_NAME,
                       sizeof(cl_char)*1024,
                       deviceName,
                       NULL );
      printf("\n Device %d
              \n Platform name: %s
              \n Vendor: %s
              \n Device name: %s",
              hardList[i].devNum,
              platformName,
              platformVendor,
              deviceName );
   }
}
*/